// TIP ANIMATOR v1.2 (12.08.2008) by Tebe/Madteam

program anm_tip;

{$APPTYPE CONSOLE}

uses
  SysUtils;

var
 a0, a1, a2, b0, b1, b2: array [0..8191] of byte;

 dic: array [0..20000] of byte;

 i, dicLen, dicCnt, first, last: integer;

 plik: file;


procedure load_a(i: integer);
var f: file;
    a: string;
    s: integer;
begin

 a:=IntToStr(i);

 while length(a)<4 do a:='0'+a;

 assignfile(f, a+'.tip'); reset(f,1);
 S:=FileSize(f)-9;

 blockread(f, a0, 9);
 blockread(f, a0, s div 3);
 blockread(f, a1, s div 3);
 blockread(f, a2, s div 3);
 closefile(f);

end;


procedure load_b(i: integer);
var f: file;
    a: string;
    s: integer;
begin

 a:=IntToStr(i);

 while length(a)<4 do a:='0'+a;

 assignfile(f, a+'.tip'); reset(f,1);
 S:=FileSize(f)-9;

 blockread(f, b0, 9);
 blockread(f, b0, s div 3);
 blockread(f, b1, s div 3);
 blockread(f, b2, s div 3);
 closefile(f);

end;


function search(k, min_y, max_y: integer; var b:array of byte): integer;
var i, j, x: integer;
    ok: Boolean;
begin

 Result:=dicLen;

 i:=0;

 while i<dicLen-(max_y-min_y) do begin

  ok:=true;
  j:=0;
  for x:=min_y to max_y do begin
   if (dic[i+j]<>b[k+x*40]) then begin ok:=false; Break end;

   inc(j);
  end;

  if ok then begin Result:=i; exit end;

  inc(i);
 end;

// nie znalazl, dopisz do slownika
 for x:=min_y to max_y do begin
  dic[dicLen]   := b[k+x*40];

  inc(dicLen);
 end;

end;



procedure compare;
var i,j, a,b, min_y, max_y, idx, h: integer;
    bf: array [0..15] of byte;
    d: file;
begin

 for i:=0 to 39 do begin

  j:=0;
  min_y:=255; max_y:=0;

  while j<=100 do begin

   a:=j;

   while ((a0[i+j*40]=b0[i+j*40]) and (a1[i+j*40]=b1[i+j*40]) and (a2[i+j*40]=b2[i+j*40])) and (j<=100) do inc(j);

   b:=j;

   while ((a0[i+j*40]<>b0[i+j*40]) or (a1[i+j*40]<>b1[i+j*40]) or (a2[i+j*40]<>b2[i+j*40])) and (j<=100) do inc(j);

   if b<min_y then min_y:=b;
   if a>max_y then max_y:=a;

  end;


  if min_y>max_y then begin
//   write($ff,',')
//   bf[0]:=0;
//   blockwrite(plik, bf, 1);
  end else begin
//   write(min_y,'-',max_y,',');

   h:=max_y-min_y;


   if h>126 then begin
    writeln('ERROR: H>126');
    halt;
   end else
    if h<0 then begin
     writeln('ERROR: H<0');
     halt;
    end else
     if h=0 then begin
      writeln('ERROR: H=0');
      halt;
     end;


   if dicLen+h*3>16383 then begin

    assignfile(d, 'dic'+IntToStr(dicCnt)+'.dat'); rewrite(d,1);
    blockwrite(d, dic, dicLen);
    closefile(d);

    inc(dicCnt);

    bf[0]:=$ff;
    blockwrite(plik, bf, 1);          // nastepny bank pamieci

    fillchar(dic, sizeof(dic), 0);

    dicLen:=0;
   end;


   bf[0]:=h or $80;                   // wysokosc kolumny, jednakowa dla wszystkich 3 buforow
   bf[1]:=i;                          // pozycja pozioma
   bf[2]:=min_y;                      // pionowa pozycja poczatkowa
   blockwrite(plik, bf, 3);


   idx:=search(i, min_y, max_y, b0) + $4000;

   bf[1]:=byte(idx shr 8);            // indeks do kolumny B0
   bf[0]:=byte(idx);
   blockwrite(plik, bf, 2);


   idx:=search(i, min_y, max_y, b1) + $4000;

   bf[1]:=byte(idx shr 8);            // indeks do kolumny B1
   bf[0]:=byte(idx);
   blockwrite(plik, bf, 2);


   idx:=search(i, min_y, max_y, b2) + $4000;

   bf[1]:=byte(idx shr 8);            // indeks do kolumny B2
   bf[0]:=byte(idx);
   blockwrite(plik, bf, 2);

  end;

 end;

 bf[0]:=$80;
 blockwrite(plik, bf, 1);

end;



begin
 writeln('TIPANM v1.2 by Tebe/Madteam');

 if paramCount>0 then begin
  first:=StrToInt(ParamStr(1));
  last:=StrToInt(ParamStr(2));
 end else begin
  writeln('Usage: TIPANM FIRST LAST');
  writeln('Example: TIPANM 1 24'#13#10'File: 0001.tip, 0002.tip ... 0024.tip');
  halt;
 end;

 assignfile(plik, 'anm.dat'); rewrite(plik,1);

 for i:=first to last-1 do begin

  load_a(i);
  load_b(i+1);

  compare;

 end;

 load_a(last);
 load_b(first);

 compare;


 i:=255;
 blockwrite(plik, byte(i), 1);          // nastepny bank pamieci


 closefile(plik);


 if dicLen>0 then begin

  assignfile(plik, 'dic'+IntToStr(dicCnt)+'.dat'); rewrite(plik,1);
  blockwrite(plik, dic, dicLen);
  closefile(plik);
 end;

end.
